
/* ipa-bscmgmt-mib.h
 * Definitions for ip.access BSC Management dissection
 * Copyright 2004, ip.access Ltd <Neil.Piercy@ipaccess.com>
 *
 * $Id: epan/dissectors/ipa-bscmgmt-mib.h 1.3 2008/05/30 13:41:45BST Neil P Piercy (npp) Exp  $
 *
 * Ethereal - Network traffic analyzer
 * By Gerald Combs <gerald@unicom.net>
 * Copyright 1998 Gerald Combs
 */

#ifndef IPA_BSCMGMT_MIB_H

static const value_string dn_vals[] = {
    { 5, "BBT" },
    { 5, "BBT" },
    { 5, "BBT" },
    { 5, "BBT" },
    { 5, "BBT" },
    { 1, "BSC" },
    { 1, "BSC" },
    { 1, "BSC" },
    { 1, "BSC" },
    { 1, "BSC" },
    { 70, "BSC_RACK" },
    { 70, "BSC_RACK" },
    { 0, "BSS" },
    { 0, "BSS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 3, "BTS" },
    { 119, "BTS_SW_MANAGER" },
    { 43, "CCT_A_IF" },
    { 43, "CCT_A_IF" },
    { 6, "CH" },
    { 6, "CH" },
    { 6, "CH" },
    { 78, "CPU" },
    { 71, "CPU_CARD" },
    { 71, "CPU_CARD" },
    { 71, "CPU_CARD" },
    { 79, "CPU_CHIP" },
    { 74, "DISK" },
    { 48, "E1" },
    { 57, "EVENT_LOGGER" },
    { 72, "FAN" },
    { 76, "FILESYSTEM" },
    { 76, "FILESYSTEM" },
    { 94, "FLEXWAVE" },
    { 101, "FOREIGN_3GFDD_CELL" },
    { 101, "FOREIGN_3GFDD_CELL" },
    { 101, "FOREIGN_3GFDD_CELL" },
    { 101, "FOREIGN_3GFDD_CELL" },
    { 101, "FOREIGN_3GFDD_CELL" },
    { 59, "FOREIGN_CELL" },
    { 59, "FOREIGN_CELL" },
    { 59, "FOREIGN_CELL" },
    { 59, "FOREIGN_CELL" },
    { 59, "FOREIGN_CELL" },
    { 59, "FOREIGN_CELL" },
    { 59, "FOREIGN_CELL" },
    { 59, "FOREIGN_CELL" },
    { 59, "FOREIGN_CELL" },
    { 56, "FR_CARD" },
    { 54, "FR_E1" },
    { 52, "FR_LINK" },
    { 55, "FR_T1" },
    { 51, "FRIP" },
    { 53, "FRIP_NSVC" },
    { 60, "FRIP_UDP_TERMINATION" },
    { 103, "GBIP_DYNAMIC" },
    { 105, "GBIP_GNAT_NSVC" },
    { 106, "GBIP_LOCAL_NSVL" },
    { 108, "GBIP_PROVISIONED_REMOTE_NSVL" },
    { 107, "GBIP_REMOTE_NSVL" },
    { 114, "GBIP_SGSN_CONFIGURED_REMOTE_NSVL" },
    { 104, "GBIP_STATIC" },
    { 39, "GNAT" },
    { 39, "GNAT" },
    { 42, "GNAT_BTS_NSE" },
    { 42, "GNAT_BTS_NSE" },
    { 38, "GNAT_BTS_NSVC" },
    { 40, "GNAT_BTS_SET" },
    { 40, "GNAT_BTS_SET" },
    { 41, "GNAT_CELL" },
    { 36, "GNAT_SGSN_NSE" },
    { 36, "GNAT_SGSN_NSE" },
    { 37, "GNAT_SGSN_NSVC" },
    { 61, "GNAT_UDP_TERMINATION" },
    { 8, "GPRS_CELL" },
    { 8, "GPRS_CELL" },
    { 8, "GPRS_CELL" },
    { 8, "GPRS_CELL" },
    { 8, "GPRS_CELL" },
    { 8, "GPRS_CELL" },
    { 8, "GPRS_CELL" },
    { 97, "GPRS_MULTIPLEXER" },
    { 98, "GPRS_MUX_UDP_TERMINATION" },
    { 7, "GPRS_NSE" },
    { 7, "GPRS_NSE" },
    { 7, "GPRS_NSE" },
    { 9, "GPRS_NSVC" },
    { 99, "GPRS_SRTP_MULTIPLEXER" },
    { 100, "GPRS_SRTP_MUX_UDP_TERMINATION" },
    { 116, "GPRS_SRTP_SESSION" },
    { 96, "GPS" },
    { 44, "GW" },
    { 63, "IP_A_INTERFACE" },
    { 63, "IP_A_INTERFACE" },
    { 64, "IP_MEDIA_GATEWAY" },
    { 115, "LB_IF" },
    { 11, "LOG" },
    { 110, "MF_ABIS_TRAFFIC" },
    { 81, "MF_AMR" },
    { 65, "MF_BTS_INTER_CELL_HO" },
    { 66, "MF_BTS_INTER_CELL_HO_DETAILS" },
    { 25, "MF_CCCH" },
    { 21, "MF_CCCH_UTILISATION" },
    { 82, "MF_CHAN_ASSIGN" },
    { 20, "MF_CS_CCCH" },
    { 30, "MF_DOWNLINK_TBF" },
    { 30, "MF_DOWNLINK_TBF" },
    { 26, "MF_GPRS_CCCH" },
    { 27, "MF_GPRS_CCCH_DETAILS" },
    { 28, "MF_GPRS_ESTABLISHMENT" },
    { 120, "MF_GPRS_MUX_PERFORMANCE" },
    { 121, "MF_GPRS_MUX_USAGE" },
    { 17, "MF_HANDOVER" },
    { 17, "MF_HANDOVER" },
    { 112, "MF_HANDOVER_NEIGHBOURS" },
    { 24, "MF_HANDOVER_REQUIRED_DETAILS" },
    { 113, "MF_HANDOVER_SDCCH" },
    { 12, "MF_IMMEDIATE_ASSIGN" },
    { 12, "MF_IMMEDIATE_ASSIGN" },
    { 22, "MF_IMMEDIATE_ASSIGN_DETAILS" },
    { 22, "MF_IMMEDIATE_ASSIGN_DETAILS" },
    { 111, "MF_LCS" },
    { 35, "MF_LINK_ADAPTATION" },
    { 32, "MF_LLC_DATA" },
    { 32, "MF_LLC_DATA" },
    { 23, "MF_MEASUREMENT_PROCESSING" },
    { 23, "MF_MEASUREMENT_PROCESSING" },
    { 33, "MF_PDCH" },
    { 34, "MF_PDCH_USAGE" },
    { 16, "MF_RR_CONNECTION" },
    { 16, "MF_RR_CONNECTION" },
    { 91, "MF_RTP_MUX_PERFORMANCE" },
    { 90, "MF_RTP_MUX_USAGE" },
    { 19, "MF_RTP_PERFORMANCE" },
    { 18, "MF_RTP_USAGE" },
    { 13, "MF_SDCCH_USAGE" },
    { 13, "MF_SDCCH_USAGE" },
    { 92, "MF_SRTP_MUX_USAGE" },
    { 31, "MF_TBF_USAGE" },
    { 14, "MF_TCH" },
    { 14, "MF_TCH" },
    { 15, "MF_TCH_USAGE" },
    { 15, "MF_TCH_USAGE" },
    { 15, "MF_TCH_USAGE" },
    { 80, "MF_TCH_USAGE_DETAILS" },
    { 80, "MF_TCH_USAGE_DETAILS" },
    { 29, "MF_UPLINK_TBF" },
    { 29, "MF_UPLINK_TBF" },
    { 50, "MGW" },
    { 50, "MGW" },
    { 67, "MGW_CIRCUIT" },
    { 95, "MICROBTS" },
    { 46, "MTP2" },
    { 73, "PSU" },
    { 77, "RACK_MONITOR" },
    { 75, "RAID_ARRAY" },
    { 4, "RC" },
    { 4, "RC" },
    { 4, "RC" },
    { 4, "RC" },
    { 4, "RC" },
    { 4, "RC" },
    { 85, "RTP_MULTIPLEXER" },
    { 88, "RTP_MUX_UDP_TERMINATION" },
    { 83, "RTP_SUBAGENT" },
    { 83, "RTP_SUBAGENT" },
    { 10, "SCANNER" },
    { 10, "SCANNER" },
    { 10, "SCANNER" },
    { 10, "SCANNER" },
    { 45, "SGW" },
    { 2, "SITE" },
    { 2, "SITE" },
    { 2, "SITE" },
    { 2, "SITE" },
    { 2, "SITE" },
    { 118, "SR" },
    { 86, "SRTP_MULTIPLEXER" },
    { 89, "SRTP_MUX_UDP_TERMINATION" },
    { 87, "SRTP_SESSION" },
    { 93, "SSL_FUNCTION" },
    { 117, "SW_MANAGER" },
    { 49, "T1" },
    { 109, "TEST_CHANNEL" },
    { 68, "TIMESLOT" },
    { 69, "USER" },
    { 69, "USER" },

	{ 0, NULL }
};

static const value_string obj_class_vals[] = {
    { 1000, "aInterface_000" },
    { 2000, "basebandTransceiver_000" },
    { 2001, "basebandTransceiver_001" },
    { 2002, "basebandTransceiver_002" },
    { 2003, "basebandTransceiver_003" },
    { 2004, "basebandTransceiver_004" },
    { 2005, "basebandTransceiver_005" },
    { 114000, "testChannel_000" },
    { 114001, "testChannel_001" },
    { 3000, "bsc_000" },
    { 3001, "bsc_001" },
    { 3002, "bsc_002" },
    { 3003, "bsc_003" },
    { 3004, "bsc_004" },
    { 3005, "bsc_005" },
    { 75000, "bscRack_000" },
    { 75001, "bscRack_001" },
    { 75002, "bscRack_002" },
    { 4000, "bss_000" },
    { 4001, "bss_001" },
    { 4002, "bss_002" },
    { 5005, "bts1800_004" },
    { 5013, "bts1800_005" },
    { 5006, "bts1900_004" },
    { 5051, "bts1800_006" },
    { 5014, "bts1900_005" },
    { 5052, "bts1900_006" },
    { 5000, "bts_000" },
    { 5001, "bts_001" },
    { 5002, "bts_002" },
    { 5003, "bts_003" },
    { 5004, "bts_004" },
    { 5012, "bts_005" },
    { 5050, "bts_006" },
    { 5010, "btsEdge1800_004" },
    { 5018, "btsEdge1800_005" },
    { 5053, "btsEdge1800_006" },
    { 5011, "btsEdge1900_004" },
    { 5019, "btsEdge1900_005" },
    { 5054, "btsEdge1900_006" },
    { 5007, "btsMulti1800_004" },
    { 5015, "btsMulti1800_005" },
    { 5055, "btsMulti1800_006" },
    { 5008, "btsMulti1900_004" },
    { 5016, "btsMulti1900_005" },
    { 5009, "btsMulti900_004" },
    { 5017, "btsMulti900_005" },
    { 5057, "btsMulti900_006" },
    { 5056, "btsMulti1900_006" },
    { 6000, "btsNse_000" },
    { 6001, "btsNse_001" },
    { 6002, "btsNse_002" },
    { 7000, "btsNsvc_000" },
    { 7001, "btsNsvc_001" },
    { 8000, "btsSiteManager_000" },
    { 8001, "btsSiteManager_001" },
    { 8002, "btsSiteManager_002" },
    { 8003, "btsSiteManager_003" },
    { 8004, "btsSiteManager_004" },
    { 8005, "btsSiteManager_005" },
    { 9000, "channel_000" },
    { 9001, "channel_001" },
    { 9002, "channel_002" },
    { 9003, "channelAmr_002" },
    { 10000, "circuitAInterface_000" },
    { 10001, "circuitAInterface_001" },
    { 90000, "cpu_000" },
    { 90001, "cpu_001" },
    { 76000, "cpuCard_000" },
    { 76001, "cpuCard_001" },
    { 76002, "cpuCard_002" },
    { 76003, "cpuCard_003" },
    { 91000, "cpuChip_000" },
    { 91001, "cpuChip_001" },
    { 79000, "disk_000" },
    { 79001, "disk_001" },
    { 11000, "e1Link_000" },
    { 11001, "e1Link_001" },
    { 73000, "eventLogger_000" },
    { 73001, "eventLogger_001" },
    { 77000, "fan_000" },
    { 77001, "fan_001" },
    { 80000, "filesystem_000" },
    { 80001, "filesystem_001" },
    { 80002, "filesystem_002" },
    { 106000, "flexwaveManager_000" },
    { 106001, "flexwaveManager_001" },
    { 107000, "flexwaveMicroBts_000" },
    { 107001, "flexwaveMicroBts_001" },
    { 13000, "foreignCell_000" },
    { 13001, "foreignCell_001" },
    { 13003, "foreignCellDcs1800_002" },
    { 13002, "foreignCellEGsm900_002" },
    { 13007, "foreignCellGsm450_002" },
    { 13008, "foreignCellGsm480_002" },
    { 13009, "foreignCellGsm850_002" },
    { 13004, "foreignCellPcs1900_002" },
    { 13005, "foreignCellPGsm900_002" },
    { 13006, "foreignCellRGsm900_002" },
    { 14000, "foreignObject_000" },
    { 128000, "softwareManager_000" },
    { 128001, "softwareManager_001" },
    { 129000, "btsSoftwareManager_000" },
    { 129001, "btsSoftwareManager_001" },
    { 180000, "systemRelease_000" },
    { 180001, "systemRelease_001" },
    { 140001, "foreign3gFddObject_000" },
    { 123000, "foreign3gFddCell_000" },
    { 130001, "foreign3gFddCell_001" },
    { 123001, "foreign3gFddCellBand1_000" },
    { 123002, "foreign3gFddCellBand2_000" },
    { 123003, "foreign3gFddCellBand3_000" },
    { 123004, "foreign3gFddCellBand4_000" },
    { 110000, "mfAbisTraffic_000" },
    { 110001, "mfAbisTraffic_001" },
    { 170000, "mfLcs_000" },
    { 170001, "mfLcs_001" },
    { 150000, "mfHandoverNeighbours_000" },
    { 150001, "mfHandoverNeighbours_001" },
    { 160000, "mfHandoverSdcch_000" },
    { 160001, "mfHandoverSdcch_001" },
    { 40002, "mfDownlinkTbf_002" },
    { 44002, "mfHandover_002" },
    { 47002, "mfImmediateAssignDetails_002" },
    { 46002, "mfImmediateAssign_002" },
    { 49002, "mfLlcData_002" },
    { 50002, "mfMeasurementProcessing_002" },
    { 60002, "mfUplinkTbf_002" },
    { 53002, "mfRrConnection_002" },
    { 58002, "mfTch_002" },
    { 59003, "mfTchUsage_003" },
    { 56002, "mfSdcchUsage_002" },
    { 92002, "mfTchUsageDetails_002" },
    { 29006, "gprsCell_004" },
    { 29007, "gprsCellEgprs_005" },
    { 10002, "circuitAInterface_002" },
    { 95002, "rtpSubagent_002" },
    { 115000, "gprsMultiplexer_000" },
    { 115001, "gprsMultiplexer_001" },
    { 126000, "gprsSrtpMultiplexer_000" },
    { 126001, "gprsSrtpMultiplexer_001" },
    { 127000, "gprsSrtpMuxUdpTermination_000" },
    { 127001, "gprsSrtpMuxUdpTermination_001" },
    { 125000, "gprsMuxUdpTermination_000" },
    { 125001, "gprsMuxUdpTermination_001" },
    { 2900, "lbInterface_000" },
    { 2901, "lbInterface_001" },
    { 190000, "gprsSrtpSession_000" },
    { 190001, "gprsSrtpSession_001" },
    { 132000, "mfGprsMuxPerformance_000" },
    { 132001, "mfGprsMuxPerformance_001" },
    { 131000, "mfGprsMuxUsage_000" },
    { 131001, "mfGprsMuxUsage_001" },
    { 71000, "frCard_000" },
    { 71001, "frCard_001" },
    { 15000, "frE1Link_000" },
    { 15001, "frE1Link_001" },
    { 16000, "frip_000" },
    { 16001, "frip_001" },
    { 17000, "fripNsvc_000" },
    { 17001, "fripNsvc_001" },
    { 70000, "fripUdpTermination_000" },
    { 70001, "fripUdpTermination_001" },
    { 18000, "frLink_000" },
    { 18001, "frLink_001" },
    { 87000, "frPcmLink_000" },
    { 19000, "frT1Link_000" },
    { 19001, "frT1Link_001" },
    { 20000, "gateway_000" },
    { 20001, "gateway_001" },
    { 21000, "gnat_000" },
    { 21001, "gnat_001" },
    { 21002, "gnat_002" },
    { 22000, "gnatBtsNse_000" },
    { 22001, "gnatBtsNse_001" },
    { 22002, "gnatBtsNse_002" },
    { 23000, "gnatBtsNsvc_000" },
    { 23001, "gnatBtsNsvc_001" },
    { 24000, "gnatBtsSet_000" },
    { 24001, "gnatBtsSet_001" },
    { 24002, "gnatBtsSet_002" },
    { 25000, "gnatCell_000" },
    { 25001, "gnatCell_001" },
    { 26000, "gnatSgsnNse_000" },
    { 26001, "gnatSgsnNse_001" },
    { 26002, "gnatSgsnNse_002" },
    { 27000, "gnatSgsnNsvc_000" },
    { 27001, "gnatSgsnNsvc_001" },
    { 28000, "gnatUdpTermination_000" },
    { 28001, "gnatUdpTermination_001" },
    { 29000, "gprsCell_000" },
    { 29001, "gprsCell_001" },
    { 29002, "gprsCell_002" },
    { 29003, "gprsCell_003" },
    { 29004, "gprsCellEgprs_003" },
    { 29005, "gprsCellEgprs_004" },
    { 108000, "gps_000" },
    { 108001, "gps_001" },
    { 74000, "gsmEquipment_000" },
    { 74001, "gsmEquipment_001" },
    { 30000, "gsmManagedFunction_000" },
    { 30001, "gsmManagedFunction_001" },
    { 88000, "gwPcmLink_000" },
    { 32000, "ipAInterface_000" },
    { 32001, "ipAInterface_001" },
    { 32002, "ipAInterface_002" },
    { 33000, "ipMediaGateway_000" },
    { 33001, "ipMediaGateway_001" },
    { 34000, "log_000" },
    { 34001, "log_001" },
    { 35000, "measurementFunction_000" },
    { 84000, "measurementFunctionBsc_000" },
    { 85000, "measurementFunctionBts_000" },
    { 86000, "measurementFunctionGprsCell_000" },
    { 36000, "mediaGateway_000" },
    { 36001, "mediaGateway_001" },
    { 36002, "mediaGateway_002" },
    { 93000, "mfAmr_000" },
    { 93001, "mfAmr_001" },
    { 82000, "mfBtsIntInterCellHo_000" },
    { 82001, "mfBtsIntInterCellHo_001" },
    { 83000, "mfBtsIntInterCellHoDetails_000" },
    { 83001, "mfBtsIntInterCellHoDetails_001" },
    { 37000, "mfCcch_000" },
    { 37001, "mfCcch_001" },
    { 38000, "mfCcchUtilisation_000" },
    { 38001, "mfCcchUtilisation_001" },
    { 94000, "mfChannelAssign_000" },
    { 94001, "mfChannelAssign_001" },
    { 39000, "mfCsCcch_000" },
    { 39001, "mfCsCcch_001" },
    { 40000, "mfDownlinkTbf_000" },
    { 40001, "mfDownlinkTbf_001" },
    { 41000, "mfGprsCcch_000" },
    { 41001, "mfGprsCcch_001" },
    { 42000, "mfGprsCcchDetails_000" },
    { 42001, "mfGprsCcchDetails_001" },
    { 43000, "mfGprsEstablishment_000" },
    { 43001, "mfGprsEstablishment_001" },
    { 44000, "mfHandover_000" },
    { 44001, "mfHandover_001" },
    { 45000, "mfHandoverRequiredDetails_000" },
    { 45001, "mfHandoverRequiredDetails_001" },
    { 46000, "mfImmediateAssign_000" },
    { 46001, "mfImmediateAssign_001" },
    { 47000, "mfImmediateAssignDetails_000" },
    { 47001, "mfImmediateAssignDetails_001" },
    { 48000, "mfLinkAdaptation_000" },
    { 48001, "mfLinkAdaptation_001" },
    { 49000, "mfLlcData_000" },
    { 49001, "mfLlcData_001" },
    { 50000, "mfMeasurementProcessing_000" },
    { 50001, "mfMeasurementProcessing_001" },
    { 51000, "mfPdch_000" },
    { 51001, "mfPdch_001" },
    { 52000, "mfPdchUsage_000" },
    { 52001, "mfPdchUsage_001" },
    { 53000, "mfRrConnection_000" },
    { 53001, "mfRrConnection_001" },
    { 102000, "mfRtpMuxPerformance_000" },
    { 102001, "mfRtpMuxPerformance_001" },
    { 103000, "mfRtpMuxUsage_000" },
    { 103001, "mfRtpMuxUsage_001" },
    { 54000, "mfRtpPerformance_000" },
    { 54001, "mfRtpPerformance_001" },
    { 55000, "mfRtpUsage_000" },
    { 55001, "mfRtpUsage_001" },
    { 56000, "mfSdcchUsage_000" },
    { 56001, "mfSdcchUsage_001" },
    { 104000, "mfSrtpMuxUsage_000" },
    { 104001, "mfSrtpMuxUsage_001" },
    { 57000, "mfTbfUsage_000" },
    { 57001, "mfTbfUsage_001" },
    { 58000, "mfTch_000" },
    { 58001, "mfTch_001" },
    { 59000, "mfTchUsage_000" },
    { 59001, "mfTchUsage_001" },
    { 59002, "mfTchUsage_002" },
    { 92000, "mfTchUsageDetails_000" },
    { 92001, "mfTchUsageDetails_001" },
    { 60000, "mfUplinkTbf_000" },
    { 60001, "mfUplinkTbf_001" },
    { 61000, "mgwCircuit_000" },
    { 61001, "mgwCircuit_001" },
    { 62000, "mtp2Link_000" },
    { 62001, "mtp2Link_001" },
    { 63000, "pcmLink_000" },
    { 78000, "psu_000" },
    { 78001, "psu_001" },
    { 89000, "rackMonitor_000" },
    { 89001, "rackMonitor_001" },
    { 64002, "radioCarrier1800_001" },
    { 64004, "radioCarrier1900_001" },
    { 64000, "radioCarrier_000" },
    { 64001, "radioCarrier_001" },
    { 64005, "radioCarrierEdge1800_001" },
    { 64006, "radioCarrierEdge1900_001" },
    { 64007, "radioCarrierGmsk1800_001" },
    { 64008, "radioCarrierGmsk1900_001" },
    { 64003, "radioCarrierGmsk900_001" },
    { 81000, "raidArray_000" },
    { 81001, "raidArray_001" },
    { 97000, "rtpMultiplexer_000" },
    { 97001, "rtpMultiplexer_001" },
    { 100000, "rtpMuxUdpTermination_000" },
    { 100001, "rtpMuxUdpTermination_001" },
    { 95000, "rtpSubagent_000" },
    { 95001, "rtpSubagent_001" },
    { 116000, "gbip_000" },
    { 117000, "gbipStatic_001" },
    { 118000, "gbipDynamic_001" },
    { 121000, "gbipLocalNsvl_000" },
    { 121001, "gbipLocalNsvl_001" },
    { 119000, "gbipRemoteNsvl_000" },
    { 119001, "gbipRemoteNsvl_001" },
    { 120000, "gbipGnatNsvc_000" },
    { 120001, "gbipGnatNsvc_001" },
    { 124000, "gbipProvisinedRemoteNsvl_000" },
    { 124001, "gbipProvisinedRemoteNsvl_001" },
    { 122000, "gbipSgsnConfiguredRemoteNsvl_000" },
    { 122001, "gbipSgsnConfiguredRemoteNsvl_001" },
    { 65000, "scanner_000" },
    { 65001, "scanner_001" },
    { 65002, "scanner_002" },
    { 65003, "scanner_003" },
    { 65004, "scanner_004" },
    { 66000, "signallingGateway_000" },
    { 66001, "signallingGateway_001" },
    { 98000, "srtpMultiplexer_000" },
    { 98001, "srtpMultiplexer_001" },
    { 101000, "srtpMuxUdpTermination_000" },
    { 101001, "srtpMuxUdpTermination_001" },
    { 99000, "srtpSession_000" },
    { 99001, "srtpSession_001" },
    { 105000, "sslFunction_000" },
    { 105001, "sslFunction_001" },
    { 67000, "t1Link_000" },
    { 67001, "t1Link_001" },
    { 68000, "timeslot_000" },
    { 68001, "timeslot_001" },
    { 69000, "top_000" },
    { 69001, "top_001" },
    { 72000, "user_000" },
    { 72001, "user_001" },
    { 72002, "user_002" },
    { 6003, "btsNse_003" },

	{ 0, NULL }
};

static const value_string attr_id_vals[] = {
    { 1689, "abisObjectVersion" },
    { 1690, "abisObjectVersionControl" },
    { 1656, "abisObjectVersionList" },
    { 1141, "abTermRrSdcch" },
    { 1144, "abTermRrSdcchRf" },
    { 1143, "abTermRrTchAss" },
    { 146, "abTermRrTchAssRf" },
    { 1142, "abTermRrTchImmAss" },
    { 1145, "abTermRrTchImmAssRf" },
    { 1763, "activeSwVersion" },
    { 1378, "additionalInformation" },
    { 1377, "additionalText" },
    { 31, "administrativeState" },
    { 1126, "allAvailSdcchAlloc" },
    { 1125, "allAvailSdcchAllocTime" },
    { 1135, "allAvailTchAlloc" },
    { 1134, "allAvailTchAllocTime" },
    { 1678, "allAvailTchFAllocTime" },
    { 1679, "allAvailTchHAllocTime" },
    { 1500, "allowAsTimingSource" },
    { 1686, "allowAutonomousHwClassChange" },
    { 1687, "allowAutonomousSwClassChange" },
    { 1688, "allowClassChange" },
    { 1714, "allowedSerialNumber" },
    { 1658, "allowImmAssTchF" },
    { 1659, "allowImmAssTchH" },
    { 30, "allowImsiAttachDetach" },
    { 1607, "alwaysSend0808Reset" },
    { 1630, "arfcn" },
    { 1277, "associatedLogFileStem" },
    { 1099, "attCsImmAss" },
    { 1122, "attCsImmAssCause" },
    { 1101, "attCsImmAssSdcch" },
    { 1103, "attCsImmAssTch" },
    { 1097, "attCsPage" },
    { 1205, "attDlTbf" },
    { 1559, "attIcIntInterCellHo" },
    { 1560, "attOgIntInterCellHo" },
    { 1118, "attPageReq" },
    { 1374, "attributeList" },
    { 1620, "attributeMeasureList" },
    { 1380, "attributeValueChangeDefinition" },
    { 1130, "attTch" },
    { 1132, "attTchBlock" },
    { 1202, "attUlTbf" },
    { 33, "availabilityStatus" },
    { 1124, "availSdcch" },
    { 40, "basebandTransceiverId" },
    { 1171, "bcastSi16and17onBcch" },
    { 1297, "bcchFrequency" },
    { 1641, "bcchFrequencyDcs1800" },
    { 1640, "bcchFrequencyEGsm900" },
    { 1645, "bcchFrequencyGsm450" },
    { 1646, "bcchFrequencyGsm480" },
    { 1647, "bcchFrequencyGsm850" },
    { 1642, "bcchFrequencyPcs1900" },
    { 1643, "bcchFrequencyPGsm900" },
    { 1644, "bcchFrequencyRGsm900" },
    { 1694, "bepPeriod" },
    { 1585, "boardOverTemperatureThreshold" },
    { 1571, "boardTemperature" },
    { 1575, "boardTemperatureWarningThreshold" },
    { 1517, "bootpDelay" },
    { 1516, "bootpRetries" },
    { 1071, "bsapProtocol" },
    { 1070, "bsapSsn" },
    { 1737, "bscEquipmentIdentity" },
    { 1712, "bscSslControl" },
    { 80, "bsIdentityCode" },
    { 1040, "bssgpBlockingRetries" },
    { 1049, "bssgpCapabilityUpdateRetries" },
    { 1048, "bssgpCapabilityUpdateTimer" },
    { 1043, "bssgpResetRetries" },
    { 1042, "bssgpResetTimer" },
    { 1047, "bssgpResumeRetries" },
    { 1046, "bssgpResumeTimer" },
    { 1045, "bssgpSuspendRetries" },
    { 1044, "bssgpSuspendTimer" },
    { 1576, "bssgpUnblockingBlockingRetries" },
    { 1039, "bssgpUnblockingBlockingTimer" },
    { 1041, "bssgpUnblockingRetries" },
    { 1, "bssId" },
    { 85, "bssMapT10" },
    { 86, "bssMapT13" },
    { 82, "bssMapT4" },
    { 83, "bssMapT7" },
    { 84, "bssMapT8" },
    { 1030, "btsBvci" },
    { 1582, "btsDn" },
    { 1734, "btsSecurityPossible" },
    { 1716, "btsSerialNumber" },
    { 1713, "btsSslControl" },
    { 1740, "btsSslControlActive" },
    { 1110, "c2Parameters" },
    { 1089, "callAgentIpAddress" },
    { 1957, "downloadServerIpAddress" },
    { 120, "callReestablishmentAllowed" },
    { 130, "carrierFrequencyList" },
    { 132, "carrierFrequencyListDcs1800" },
    { 131, "carrierFrequencyListEGsm900" },
    { 133, "carrierFrequencyListPcs1900" },
    { 1460, "cbchDefaultMessage" },
    { 140, "cellAllocation" },
    { 141, "cellAllocation_001" },
    { 143, "cellAllocationDcs1800" },
    { 142, "cellAllocationEGsm900" },
    { 144, "cellAllocationPcs1900" },
    { 160, "cellBarred" },
    { 170, "cellGlobalIdentity" },
    { 180, "cellReselectHysteresis" },
    { 190, "channelCombination" },
    { 191, "channelCombinationAmr" },
    { 1121, "chanReq" },
    { 1583, "childObjectClasses" },
    { 1351, "cic" },
    { 1569, "cicEndian" },
    { 1603, "cipherModeCompleteL3Msg" },
    { 1112, "codecsSupported" },
    { 1113, "codecsSupported_001" },
    { 1587, "codingSchemes" },
    { 1557, "codingSchemesEgprs" },
    { 1695, "codingSchemesEgprs_001" },
    { 1494, "connTime" },
    { 1061, "countdownValue" },
    { 1586, "cpuOverTemperatureThreshold" },
    { 1572, "cpuTemperature" },
    { 1574, "cpuTemperatureWarningThreshold" },
    { 1573, "cpuUsage" },
    { 1592, "cpuUsageSystem" },
    { 1598, "cpuUsageThreshold" },
    { 1593, "cpuUsageUser" },
    { 1011, "csdJitterBuffer" },
    { 1496, "csPageReqSgsn" },
    { 1193, "cumDurPktDlAssCcch" },
    { 1570, "dateTime" },
    { 1492, "defaultMcc" },
    { 1483, "defaultMnc" },
    { 1604, "directedRetryAssignmentFailure" },
    { 1606, "disableCtmSupportInEmergencySetup" },
    { 1599, "diskStatus" },
    { 1667, "dlAmrFrCsChange" },
    { 1668, "dlAmrHrCsChange" },
    { 1245, "dlBlksCs" },
    { 1247, "dlBlksErrCs" },
    { 1335, "dlci" },
    { 1244, "dlCsChange" },
    { 1232, "dlEmptyBlks" },
    { 1216, "dlLlcOct" },
    { 1218, "dlLlcPdu" },
    { 1174, "dlLlcPduDisc" },
    { 1724, "dlMuxPkts" },
    { 1725, "dlMuxPktsLost" },
    { 1233, "dlPacchBlks" },
    { 1235, "dlPbcchBlks" },
    { 1234, "dlPccchBlks" },
    { 1236, "dlPdtchBlks" },
    { 1179, "dlPkts" },
    { 1183, "dlPktsDtx" },
    { 1181, "dlPktsLost" },
    { 1730, "dlSrtpOctets" },
    { 1727, "dlSrtpPkts" },
    { 1728, "dlSrtpPktsDisc" },
    { 1613, "dlTbfExtTimer" },
    { 1481, "dlTbfPdch" },
    { 1201, "dlTbfReqUlTbf" },
    { 1661, "dlTchFrBlkCodingScheme" },
    { 1663, "dlTchHrBlkCodingScheme" },
    { 1405, "drEnquiryThreshold" },
    { 1090, "drInterferenceScores" },
    { 1406, "drThresholdLi" },
    { 1407, "drThresholdNoLi" },
    { 1091, "drWeights" },
    { 205, "dtxDownlink" },
    { 210, "dtxUplink" },
    { 211, "dtxUplinkSacch" },
    { 1619, "duration" },
    { 1676, "dynamicPdchAct" },
    { 1677, "dynamicPdchDeact" },
    { 1675, "dynamicPdchDelayTch" },
    { 1433, "dynamicPdchTimeslotThresholds" },
    { 1502, "e1Framing" },
    { 1501, "e1LineCoding" },
    { 1170, "earlyClassmarkSending" },
    { 215, "emergencyCallRestricted" },
    { 1554, "enableInternalInterCellHandover" },
    { 1522, "enablePeriodicSltm" },
    { 1111, "encryptionAlgorithmsSupported" },
    { 1114, "encryptionAlgorithmsSupported_001" },
    { 1093, "endEndpointRange" },
    { 1552, "endIndicationRrCause" },
    { 1206, "estDlTbf" },
    { 1203, "estUlTbf" },
    { 1617, "eventType" },
    { 1531, "eventTypeList" },
    { 1098, "failCsPage" },
    { 1562, "failIntInterCellHoLoss" },
    { 1567, "failIntInterCellHoLossCause" },
    { 1561, "failIntInterCellHoRecon" },
    { 1566, "failIntInterCellHoReconCause" },
    { 1163, "failOgHoRecon" },
    { 1533, "fanSpeed" },
    { 1534, "fanSpeedThresholds" },
    { 1536, "filesystemFreeSpace" },
    { 1537, "filesystemFreeSpaceThreshold" },
    { 1595, "filesystemName" },
    { 1747, "flexwaveIpAddresses" },
    { 1752, "flexwaveLinkSslState" },
    { 1000, "flushReq" },
    { 1503, "frCardType" },
    { 1333, "frLinkId" },
    { 1505, "frLinkRole" },
    { 1579, "fullRateCodecControl" },
    { 1521, "g711Law" },
    { 1223, "gadAltitude" },
    { 1625, "gadAltitude_001" },
    { 1177, "gadAltitudePresent" },
    { 1220, "gadLatitude" },
    { 1627, "gadLatitude_001" },
    { 1221, "gadLongitude" },
    { 1628, "gadLongitude_001" },
    { 1222, "gadRadius" },
    { 1175, "gadRadiusPresent" },
    { 1003, "gprsCellOptions" },
    { 1063, "gprsPagingRepeatCount" },
    { 1062, "gprsPagingRepeatTime" },
    { 1372, "gprsPowerControlParameters" },
    { 1741, "gpsAltitude" },
    { 1742, "gpsLatitude" },
    { 1743, "gpsLongitude" },
    { 1748, "gpsSatellitesTracked" },
    { 23, "granularityPeriod" },
    { 1005, "gsmBand" },
    { 1007, "gsmBand_001" },
    { 1006, "gsmBandForeignCell" },
    { 1759, "gsmBandSupported" },
    { 1657, "halfRateAssThreshold" },
    { 1578, "halfRateCodecControl" },
    { 1608, "handoverCipherModeSettingBehaviour" },
    { 1600, "hoAssociationList" },
    { 290, "hoAveragingDistParam" },
    { 1242, "hoCause" },
    { 330, "hoMarginDef" },
    { 1300, "hoPriorityLevel" },
    { 1156, "hoRequiredTimer" },
    { 360, "hoThresholdDistParam" },
    { 370, "hoThresholdInterferenceParam" },
    { 380, "hoThresholdLevParam" },
    { 390, "hoThresholdQualParam" },
    { 1194, "hoTotal" },
    { 1166, "icHoAlloc" },
    { 1167, "icHoDet" },
    { 1165, "icHoReq" },
    { 1605, "ignoreCauseIn0808ClearCommand" },
    { 1733, "imlSslState" },
    { 1615, "initialCodingScheme" },
    { 1660, "initialCodingSchemeEgprs" },
    { 1696, "initialCodingSchemeEgprs_001" },
    { 400, "interferenceAveragingParam" },
    { 1549, "invokingEvent" },
    { 1363, "ipAddress" },
    { 1520, "jitterBufferDelay" },
    { 1519, "jitterBufferOptimisationFactor" },
    { 1589, "linkStatus" },
    { 1506, "lmiType" },
    { 1172, "loadIndicationReceiveTimer" },
    { 1341, "loadIndicationSendThreshold" },
    { 1339, "loadIndicationSendTimer" },
    { 1364, "localIpAddress" },
    { 1525, "localPointCode" },
    { 1956, "downloadTcpPort" },
    { 1052, "localUdpPort" },
    { 1697, "localUdpPortRange" },
    { 1541, "location" },
    { 1256, "loggingPeriodMultiplier" },
    { 1762, "manufactureDate" },
    { 1702, "masterKey" },
    { 1703, "masterSalt" },
    { 1128, "maxBusySdcch" },
    { 1683, "maxBusyTch" },
    { 1684, "maxBusyTchH" },
    { 1139, "maxBusyTsSig" },
    { 1137, "maxBusyTsTch" },
    { 1682, "maxBusyTsTchH" },
    { 1187, "maxDlJit" },
    { 1212, "maxDlTbf" },
    { 1214, "maxDlTbfTime" },
    { 1088, "maxMissedHeartbeats" },
    { 420, "maxNumberRetransmission" },
    { 1225, "maxPdch" },
    { 1189, "maxTxDelay" },
    { 1188, "maxUlJit" },
    { 1213, "maxUlTbf" },
    { 1215, "maxUlTbfTime" },
    { 1127, "meanBusySdcch" },
    { 1681, "meanBusyTchH" },
    { 1138, "meanBusyTsSig" },
    { 1136, "meanBusyTsTch" },
    { 1680, "meanBusyTsTchH" },
    { 1184, "meanDlJit" },
    { 1150, "meanDlRxLev" },
    { 1152, "meanDlRxQual" },
    { 1210, "meanDlTbf" },
    { 1117, "meanDurCsPage" },
    { 1001, "meanLlcPduQueue" },
    { 1120, "meanPchQueue" },
    { 1224, "meanPdch" },
    { 1154, "meanTa" },
    { 1186, "meanTxDelay" },
    { 1185, "meanUlJit" },
    { 1151, "meanUlRxLev" },
    { 1153, "meanUlRxQual" },
    { 1211, "meanUlTbf" },
    { 1614, "mgmtLinkHeartbeatPeriod" },
    { 1635, "mgmtLinkHeartbeatPeriod_001" },
    { 1596, "mgmtLinkTimeout" },
    { 1344, "mgwEndpointName" },
    { 1347, "mgwName" },
    { 1623, "mibVersion" },
    { 1760, "microBtsCatalogNumber" },
    { 1744, "microBtsId" },
    { 1761, "microBtsPartNumber" },
    { 1751, "microBtsSecurityPossible" },
    { 1758, "microBtsSerialNumber" },
    { 1745, "microBtsSwVersion" },
    { 1226, "minPdch" },
    { 1084, "mscIpAddress" },
    { 1553, "msClassmark" },
    { 1085, "mscPortNumber" },
    { 1325, "mscR" },
    { 475, "msTxPwrMaxCch" },
    { 476, "msTxPwrMaxCch_001" },
    { 478, "msTxPwrMaxCchDcs1800" },
    { 477, "msTxPwrMaxCchEGsm900" },
    { 479, "msTxPwrMaxCchPcs1900" },
    { 1301, "msTxPwrMaxCell" },
    { 1651, "msTxPwrMaxCellDcs1800" },
    { 490, "msTxPwrMaxCellDef" },
    { 491, "msTxPwrMaxCellDef_001" },
    { 493, "msTxPwrMaxCellDefDcs1800" },
    { 492, "msTxPwrMaxCellDefEGsm900" },
    { 494, "msTxPwrMaxCellDefPcs1900" },
    { 1650, "msTxPwrMaxCellGsm900Etc" },
    { 1652, "msTxPwrMaxCellPcs1900" },
    { 1698, "multiplexAssociationTimeout" },
    { 1717, "muxConnectionId" },
    { 1058, "n3101" },
    { 1059, "n3103" },
    { 1060, "n3105" },
    { 1755, "nanoBtsCount" },
    { 1685, "nanoBtsHwClass" },
    { 1691, "nanoBtsHwClassControl" },
    { 1655, "nanoBtsHwClasses" },
    { 1753, "nanoBtsLinkSslStateList" },
    { 1746, "nanoBtsList" },
    { 1293, "neci" },
    { 1081, "networkControlOrder" },
    { 1601, "newPassword" },
    { 500, "noOfBlocksForAccessGrant" },
    { 510, "noOfMultiframesBetweenPaging" },
    { 520, "notAllowedAccessClasses" },
    { 1616, "notificationIdentifier" },
    { 1038, "nsAliveRetries" },
    { 1037, "nsAliveTimer" },
    { 1025, "nsei" },
    { 1629, "nsei_001" },
    { 1026, "nsResetRetries" },
    { 1034, "nsResetTimer" },
    { 1036, "nsTestTimer" },
    { 1033, "nsUnblockingBlockingRetries" },
    { 1032, "nsUnblockingBlockingTimer" },
    { 1029, "nsvci" },
    { 530, "numberOfSlotsSpreadTrans" },
    { 540, "ny1" },
    { 1621, "object" },
    { 65, "objectClass" },
    { 1581, "objectInstanceId" },
    { 1618, "objectInstanceName" },
    { 1447, "objectName" },
    { 1497, "observationObjectList" },
    { 1738, "observationObjectList_001" },
    { 1162, "ogHoCmd" },
    { 1161, "ogHoReqd" },
    { 1602, "oldPassword" },
    { 1715, "omlSslState" },
    { 1735, "operationalCrlTime" },
    { 35, "operationalState" },
    { 1080, "overloadPeriod" },
    { 1543, "overTemperatureThreshold" },
    { 1119, "pageDisc" },
    { 1199, "pageProcRrPacch" },
    { 1076, "pagingRepeatCounter" },
    { 1580, "pagingRepeats" },
    { 1529, "password" },
    { 1622, "pathname" },
    { 550, "pcAveragingLev" },
    { 560, "pcAveragingQual" },
    { 570, "pcLowerThresholdLevParam" },
    { 580, "pcLowerThresholdQualParam" },
    { 600, "pcUpperThresholdLevParam" },
    { 610, "pcUpperThresholdQualParam" },
    { 1383, "perceivedSeverity" },
    { 620, "periodCcchLoadIndication" },
    { 1096, "piC2InSi7Or8" },
    { 1191, "pktChanReq" },
    { 1197, "pktChanReqCause" },
    { 1192, "pktDlAssCcch" },
    { 1190, "pktPageCcch" },
    { 1495, "pktUlAssCcch" },
    { 630, "plmnPermitted" },
    { 1768, "positionValid" },
    { 1611, "powerBudgetHandoverBehaviourSdcch" },
    { 1609, "powerBudgetHandoverBehaviourTch" },
    { 660, "powerControlInterval" },
    { 670, "powerIncrStepSize" },
    { 680, "powerRedStepSize" },
    { 1281, "primaryOamLinkIpAddress" },
    { 1075, "primaryOmlHeartbeatPeriod" },
    { 1636, "primaryOmlHeartbeatPeriod_001" },
    { 1754, "primaryOmlIpAddresses" },
    { 1279, "primaryOmlServerIpAddress" },
    { 1282, "priorityAccessThr" },
    { 1381, "probableCause" },
    { 1610, "profileOptions" },
    { 1198, "psPageReqSgsn" },
    { 1035, "pwrc" },
    { 1031, "rac" },
    { 690, "rachBusyThreshold" },
    { 700, "rachLoadAveragingSlots" },
    { 1027, "raColour" },
    { 1631, "radioChannelRateType" },
    { 1550, "radioChannelType" },
    { 1632, "radioChannelUsage" },
    { 720, "radioLinkTimeout" },
    { 1083, "radioSignallingLinkIpAddress" },
    { 1538, "raidStatus" },
    { 1087, "receiveHeartbeatPeriod" },
    { 1466, "receivePort" },
    { 1508, "relatedFripUdpTermination" },
    { 1331, "relatedLinkUser" },
    { 1542, "relatedLog" },
    { 1051, "remoteIpAddress" },
    { 1524, "remotePointCode" },
    { 1050, "remoteUdpPort" },
    { 1551, "requestTypeEstabCause" },
    { 1303, "reselectFrequencyList" },
    { 1764, "rfPowerOutput" },
    { 1280, "rotationPeriod" },
    { 1624, "rslHeartbeatPeriod" },
    { 1637, "rslHeartbeatPeriod_001" },
    { 1732, "rslSslState" },
    { 1707, "rtpKeepAliveTimeout" },
    { 1711, "rtpMultiplexerMaximumDownlinkInterval" },
    { 1709, "rtpMultiplexerMaximumDownlinkPacketSize" },
    { 1710, "rtpMultiplexerMaximumUplinkInterval" },
    { 1708, "rtpMultiplexerMaximumUplinkPacketSize" },
    { 1706, "rtpType" },
    { 770, "rxLevelAccessMin" },
    { 1302, "rxLevMinCell" },
    { 790, "rxLevMinCellDef" },
    { 1491, "sccpInactivityTestReceiveTimer" },
    { 1480, "sccpInactivityTestSendTimer" },
    { 1086, "sendHeartbeatPeriod" },
    { 1638, "sendHeartbeatPeriod_001" },
    { 1465, "sendPort" },
    { 1319, "sgsnBvci" },
    { 1320, "sgsnR" },
    { 1321, "si13Position" },
    { 1626, "si13Position_001" },
    { 1584, "signallingLinkCode" },
    { 1518, "silenceSuppression" },
    { 1523, "sioNetworkIndicator" },
    { 1700, "siteId" },
    { 1767, "siteReferenceList" },
    { 1382, "specificProblems" },
    { 1012, "speechJitterBuffer" },
    { 1169, "spgcCcchSup" },
    { 1072, "ss7Protocol" },
    { 1756, "sslControlToBts" },
    { 1750, "sslControlToManager" },
    { 1731, "sslForwardedTcpPort" },
    { 1749, "standbySwVersion" },
    { 1092, "startEndpointRange" },
    { 68, "startTime" },
    { 69, "stopTime" },
    { 1633, "subChannel" },
    { 1100, "sucCsImmAss" },
    { 1123, "sucCsImmAssCause" },
    { 1102, "sucCsImmAssSdcch" },
    { 1104, "sucCsImmAssTch" },
    { 1594, "sucCsPage" },
    { 1207, "sucDlTbf" },
    { 1168, "sucIcHo" },
    { 1563, "sucIcIntInterCellHo" },
    { 1577, "sucIntInterCellHoCause" },
    { 1164, "sucOgHo" },
    { 1564, "sucOgIntInterCellHo" },
    { 1285, "sucPktDlAssCcch" },
    { 1286, "sucPktUlAssCcch" },
    { 1283, "sucTch" },
    { 1204, "sucUlTbf" },
    { 1757, "supportedGsmBand" },
    { 1766, "swVersion" },
    { 1597, "swVersions" },
    { 1515, "t1Framing" },
    { 1514, "t1LineCoding" },
    { 1507, "t1LineDrive" },
    { 820, "t200" },
    { 1311, "t3101" },
    { 1312, "t3103" },
    { 1313, "t3105" },
    { 1314, "t3107" },
    { 1315, "t3109" },
    { 1316, "t3111" },
    { 1317, "t3113" },
    { 1318, "t3122" },
    { 1053, "t3142" },
    { 1054, "t3169" },
    { 1055, "t3191" },
    { 1056, "t3193" },
    { 1057, "t3195" },
    { 1670, "tchFrAss" },
    { 1672, "tchFrAssChanType" },
    { 1674, "tchFrSpeechAssHrAmr" },
    { 1671, "tchHrAss" },
    { 1673, "tchHrAssChanType" },
    { 1539, "temperature" },
    { 1540, "temperatureWarningThreshold" },
    { 860, "thresholdCcchLoadIndication" },
    { 1148, "timeDlPcMax" },
    { 890, "timerPeriodicUpdateMs" },
    { 1634, "timeSlot" },
    { 1149, "timeUlPcMax" },
    { 1504, "timingMaster" },
    { 1544, "tracedParty" },
    { 1545, "traceReference" },
    { 1548, "traceType" },
    { 1739, "trafficIpAddressList" },
    { 1568, "trafficMonitorTimer" },
    { 1546, "transactionId" },
    { 1155, "transmitSi1" },
    { 1701, "trxId" },
    { 1133, "tsAvailTraf" },
    { 920, "tsc" },
    { 930, "txPwrMaxReduction" },
    { 1665, "ulAmrFrCsChange" },
    { 1666, "ulAmrHrCsChange" },
    { 1246, "ulBlksCs" },
    { 1248, "ulBlksErrCs" },
    { 1309, "ulCsChange" },
    { 1217, "ulLlcOct" },
    { 1219, "ulLlcPdu" },
    { 1176, "ulLlcPduDisc" },
    { 1722, "ulMuxPktsEmpty" },
    { 1723, "ulMuxPktsLost" },
    { 1721, "ulMuxPktsSize" },
    { 1720, "ulMuxPktsTime" },
    { 1240, "ulPacchBlks" },
    { 1237, "ulPdchBlksUnused" },
    { 1241, "ulPdtchBlks" },
    { 1239, "ulPdtchBlksCrpt" },
    { 1238, "ulPdtchBlksEmpty" },
    { 1178, "ulPkts" },
    { 1180, "ulPktsLost" },
    { 1182, "ulPktsNotSent" },
    { 1729, "ulSrtpOctets" },
    { 1726, "ulSrtpPkts" },
    { 1612, "ulTbfExtTimer" },
    { 1482, "ulTbfPdch" },
    { 1200, "ulTbfReqDlTbf" },
    { 1662, "ulTchFrBlkCodingScheme" },
    { 1693, "ulTchFrBlkErrCodingScheme" },
    { 1664, "ulTchHrBlkCodingScheme" },
    { 1692, "ulTchHrBlkErrCodingScheme" },
    { 1699, "uniplexAssociationTimeout" },
    { 1528, "userAccessRights" },
    { 1527, "userName" },
    { 1719, "useRtpType" },
    { 1736, "useSsl" },
    { 300, "testStreamPayloadSize" },
    { 1765, "vswr" },
    { 1938, "installedSr" },
    { 1939, "exactMatch" },
    { 1940, "rollbackSr" },
    { 1941, "rollbackExactMatch" },
    { 1942, "priority" },
    { 1943, "systemReleaseVersion" },
    { 1944, "requiredSr" },
    { 1945, "bbtsRunningRequiredSr" },
    { 1946, "bbtsLoadedWithRequiredSr" },
    { 1947, "bbtsNotLoadedWithRequiredSr" },
    { 1948, "bandwidthLimit" },
    { 1949, "srVersion" },
    { 1950, "numOfFilesToDownload" },
    { 1951, "numOfFilesDownloaded" },
    { 1952, "componentList" },
    { 1953, "activeBankSoftwareVersion" },
    { 1954, "standbyBankSoftwareVersion" },
    { 1955, "downloadStatus" },
    { 1820, "maxNumHeartbeatAckOutstanding" },
    { 1821, "numHeartbeatDelaySample" },
    { 1822, "heartbeatRttThreshold" },
    { 1823, "numRtcpDelaySample" },
    { 1824, "rtcpRttThreshold" },
    { 1825, "userTrafficTimeout" },
    { 1815, "uarfcnBand" },
    { 1841, "uarfcnBand1" },
    { 1842, "uarfcnBand2" },
    { 1843, "uarfcnBand3" },
    { 1844, "uarfcnBand4" },
    { 1845, "uarfcnBandForeignCell" },
    { 1816, "scramblingCode" },
    { 1817, "diversity" },
    { 1819, "reselection3gList" },
    { 1827, "fddQOffset" },
    { 1828, "fddQmin" },
    { 1805, "nsMuxConfigurationType" },
    { 1800, "nsKeepAliveTimeout" },
    { 1801, "nsMultiplexerMaximumDownlinkInterval" },
    { 1802, "nsMultiplexerMaximumDownlinkPacketSize" },
    { 1803, "nsMultiplexerMaximumUplinkInterval" },
    { 1804, "nsMultiplexerMaximumUplinkPacketSize" },
    { 1769, "lastBsPower" },
    { 1770, "lastMsPower" },
    { 1771, "lastTimingAdv" },
    { 1772, "hoResult" },
    { 1773, "hoCauseTrace" },
    { 1774, "hoDuration" },
    { 1775, "targetCell" },
    { 1776, "bssmapMsg" },
    { 1777, "rrMsg" },
    { 1778, "abisMsg" },
    { 1779, "measurResultMsg" },
    { 1555, "invokingEvent_001" },
    { 1911, "ulAbisVolume" },
    { 1912, "dlAbisVolume" },
    { 1913, "ulPeakAbisRatePerSec" },
    { 1914, "dlPeakAbisRatePerSec" },
    { 1915, "ulPeakAbisRatePer10Sec" },
    { 1916, "dlPeakAbisRatePer10Sec" },
    { 1889, "mscLocReq" },
    { 1890, "mscLocRespSuc" },
    { 1891, "mscLocRespFail" },
    { 1892, "mscLocAbort" },
    { 1893, "smlcLocReq" },
    { 1894, "smlcLocRespSuc" },
    { 1895, "smlcLocRespFail" },
    { 1896, "smlcLocAbort" },
    { 1897, "utdoaReq" },
    { 1898, "utdoaRespSuc" },
    { 1899, "utdoaReject" },
    { 1900, "utdoaAbort" },
    { 1901, "taReq" },
    { 1902, "taRespSuc" },
    { 1903, "taReject" },
    { 1904, "taAbort" },
    { 1880, "sucOgSdcchHoNeigh" },
    { 1881, "sucOgTchHoNeigh" },
    { 1882, "sucIcSdcchHoNeigh" },
    { 1883, "sucIcTchHoNeigh" },
    { 1884, "attIcSdcchHoNeigh" },
    { 1885, "attIcTchHoNeigh" },
    { 1886, "attOgSdcchHoNeigh" },
    { 1887, "attOgTchHoNeigh" },
    { 1920, "ogSdcchHoReqd" },
    { 1921, "ogSdcchHoCmd" },
    { 1922, "failOgSdcchHoRecon" },
    { 1923, "sucOgSdcchHo" },
    { 1924, "icSdcchHoReq" },
    { 1848, "icSdcchHoAlloc" },
    { 1909, "icSdcchHoDet" },
    { 1849, "sucIcSdcchHo" },
    { 1850, "ogSdcchHoReqdCause" },
    { 1888, "preemptDlTbf" },
    { 1852, "failImmAssT3101" },
    { 1853, "ulGprsOctSq" },
    { 1854, "dlGprsOctSq" },
    { 1855, "ulEgprsOctSq" },
    { 1856, "dlEgprsOctSq" },
    { 1857, "ulGprsOct" },
    { 1858, "dlGprsOct" },
    { 1859, "ulEgprsOct" },
    { 1860, "dlEgprsOct" },
    { 1861, "meanDlRxLevSdcch" },
    { 1862, "meanUlRxLevSdcch" },
    { 1863, "meanDlRxLevTch" },
    { 1864, "meanUlRxLevTch" },
    { 1905, "ulRxQualDetail" },
    { 1906, "dlRxQualDetail" },
    { 1851, "chReqdDiscardCause" },
    { 1865, "abTermRrTchFrChanType" },
    { 1866, "abTermRrTchHrChanType" },
    { 1867, "abTermRrTchFrRfChanType" },
    { 1868, "abTermRrTchHrRfChanType" },
    { 1869, "abTermRrAmrTchFrRfLastUlCodecMode" },
    { 1870, "abTermRrAmrTchFrRfLastDlCodecMode" },
    { 1871, "abTermRrAmrTchHrRfLastUlCodecMode" },
    { 1872, "abTermRrAmrTchHrRfLastDlCodecMode" },
    { 1907, "meanTsAvailSdcch" },
    { 1908, "meanTsProvisionSdcch" },
    { 1873, "meanBusyTchFrChanType" },
    { 1874, "maxBusyTchFrChanType" },
    { 1875, "meanBusyTchHrChanType" },
    { 1876, "maxBusyTchHrChanType" },
    { 1917, "ctmReqCause" },
    { 1918, "ctmUnallocCause" },
    { 1919, "peakCtmCall" },
    { 1877, "meanTsAvailTraf" },
    { 1878, "meanTsProvisionTraf" },
    { 1879, "attTchBlkNoDr" },
    { 1910, "preemptUlTbf" },
    { 1925, "ogTchHoReqdCause" },
    { 1926, "attHoReqdDr" },
    { 1073, "numofGatewayCards" },
    { 1806, "nsvli" },
    { 1807, "snsGuardTimer" },
    { 1808, "snsSizeRetries" },
    { 1809, "snsConfigRetries" },
    { 1810, "snsAddRetries" },
    { 1811, "snsDeleteRetries" },
    { 1812, "snsChangeWeightRetries" },
    { 1813, "signallingWeight" },
    { 1814, "dataWeight" },
    { 1927, "useGprsType" },
    { 1929, "lcsGuardTimer" },
    { 1930, "alwaysSend0931Reset" },
    { 1931, "useBtsLocation" },
    { 1932, "smlcIpAddress" },
    { 1934, "bssapLeProtocol" },
    { 1935, "bssapLeSsn" },
    { 1936, "lbSubagentIpAddress" },
    { 1937, "handleCtmCall" },
    { 1961, "ulGprsMuxPktsTime" },
    { 1962, "ulGprsMuxPktsSize" },
    { 1963, "ulGprsMuxPktsEmpty" },
    { 1964, "dlGprsMuxPkts" },
    { 1965, "ulGprsMuxPktsLost" },
    { 1966, "dlGprsMuxPktsLost" },

	{ 0, NULL }
};

#define IPA_BSCMGMT_MIB_H
#endif
