/* packet-umts_macd.h
 *
 * Include file for UMTS MAC-D packet disassembly
 *
 * $Id: epan/dissectors/packet-umts_macd.h 1.2 2008/04/02 13:28:22BST Karthik Ganesan (kg1) Exp  $
 *
 * Copyright (c) 2007 by ip.access Ltd <support@ipaccess.com>
 *
 * Wireshark - Network traffic analyzer
 * By Gerald Combs <gerald@wireshark.org>
 * Copyright 1999 Gerald Combs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef INCLUDED_PACKET_UMTS_MACD_H
#define INCLUDED_PACKET_UMTS_MACD_H

#define RLC_MIN_UM_HEADER_SIZE 1

/** Extn Bit **/
#define EXTN_BIT_NEXT_DATA 0
#define EXTN_BIT_NEXT_LI   1

/** PDU Type **/
#define STATUS_PDU 0
#define RESET_PDU  1
#define RESET_ACK_PDU 2

/** Header Extension Type **/
#define HEADER_EXTN_TYPE_NEXT_DATA 0
#define HEADER_EXTN_TYPE_NEXT_LI   1

/** SUFI Types **/
#define NO_MORE_SUFI        0
#define WINDOW_SUFI         1
#define ACK_SUFI            2
#define LIST_SUFI           3
#define BITMAP_SUFI         4
#define RLIST_SUFI          5
#define MRW_SUFI            6
#define MRW_ACK_SUFI        7

tvbuff_t *new_octet_aligned_subset_bits(tvbuff_t *tvb, guint32 offset, guint32 no_of_bits);

#endif /* INCLUDED_PACKET_UMTS_MACD_H */

