/*
 * Copyright 1992 by Jutta Degener and Carsten Bormann, Technische
 * Universitaet Berlin.  See the accompanying file "COPYRIGHT" for
 * details.  THERE IS ABSOLUTELY NO WARRANTY FOR THIS SOFTWARE.
 */

/*$Header: gsm_csd.h 1.1 2006/07/13 18:50:45BST Neil P Piercy (npp) Exp  $*/

#ifndef	GSM_CSD_H
#define	GSM_CSD_H

#include	<stdio.h>		/* for FILE * 	*/
#include <glib.h>
/*
 *	Interface
 */

#define NUM_CSD_OCTETS  160

#define SYNC_STATE_NULL		0
#define SYNC_STATE_SEARCH	1
#define SYNC_STATE_IN_SYNC	2


typedef struct csd_state {
	int				sync_state;					/* are we synchronised to V.110 frames yet ? */
	unsigned char	frame_offset;				/* offset of RTP and CSD frames 0...NUM_CSD_OCTETS-1	*/
	int				sub_chan_rate;				/* number of active sub_channel bits: 1, 2, 4 or 8 */
	unsigned char   frame[NUM_CSD_OCTETS+8];	/* saved remains of previous RTP frame - allow for overlap if sync word crosses frame boundary */
} csd_state;

extern csd_state *gsm_csd_create(void);
extern void gsm_csd_destroy(csd_state *);	
extern int  gsm_csd_decode(csd_state *, const guint8 *, unsigned char *);
extern void copy_sub_chan(int sub_chan_rate, unsigned char *c, unsigned char *sub_chan);

#endif	/* GSM_CSD_H */
